#include<bits/stdc++.h>
using namespace std;
int kolko(long long masiv[][2],long long n,long long i){
    long long broi=0;
    for(long long j=0;j<n;j++){
        if(masiv[j][0]<=i && masiv[j][1]>=i+1){
            broi++;
        }
    }
    return broi;
}
int main(){
long long n;
long long nachalo=-1,krai=-1;
long long koord[50005][2];
cin>>n;
for(long long i=0;i<n;i++){
    cin>>koord[i][0]>>koord[i][1];
    if(i==0){
        nachalo=koord[i][0];
        krai=koord[i][1];
    }else{
        if(nachalo>koord[i][0]){
            nachalo=koord[i][0];
        }
        if(krai<koord[i][1]){
            krai=koord[i][1];
        }
    }
}
long long maks=0,br=0,sega;
/*for(long long i=nachalo;i<=krai;i++){
    sega=kolko(koord,n,i);
    if(maks<sega){
        maks=sega;
        br=1;
    }else{
        if(maks==sega){
            br++;
        }
    }
}*/

for(long long i=0;i<n;i++){
    br=1;
    for(long long j=koord[i][0];j<=koord[i][1];j++){
        sega=kolko(koord,n,j);
        if(maks<sega){
            maks=sega;
            br=1;
        }else{
            if(maks==sega){
                br++;
            }
        }
    }
}
cout<<maks<<endl<<br<<endl;
return 0;
}